Whamcloud - gitweb
LU-921 llite: warning in case of discarding dirty pages
[fs/lustre-release.git] / lustre / tests / recovery-small.sh
1 #!/bin/bash
2
3 set -e
4
5 #         bug  5494 5493  LU2034
6 ALWAYS_EXCEPT="24   52    60      $RECOVERY_SMALL_EXCEPT"
7
8 export MULTIOP=${MULTIOP:-multiop}
9 PTLDEBUG=${PTLDEBUG:--1}
10 LUSTRE=${LUSTRE:-`dirname $0`/..}
11 . $LUSTRE/tests/test-framework.sh
12 init_test_env $@
13 . ${CONFIG:=$LUSTRE/tests/cfg/$NAME.sh}
14 init_logging
15
16 require_dsh_mds || exit 0
17
18 # also long tests: 19, 21a, 21e, 21f, 23, 27
19 #                                   1  2.5  2.5    4    4          (min)"
20 [ "$SLOW" = "no" ] && EXCEPT_SLOW="17  26a  26b    50   51     57"
21
22 build_test_filter
23
24 # Allow us to override the setup if we already have a mounted system by
25 # setting SETUP=" " and CLEANUP=" "
26 SETUP=${SETUP:-""}
27 CLEANUP=${CLEANUP:-""}
28
29 check_and_setup_lustre
30
31 assert_DIR
32 rm -rf $DIR/[df][0-9]*
33
34 test_1() {
35         local f1="$DIR/$tfile"
36         local f2="$DIR/$tfile.2"
37
38         drop_request "mcreate $f1" ||
39                 error_noexit "create '$f1': drop req"
40
41         drop_reint_reply "mcreate $f2" ||
42                 error_noexit "create '$f2': drop rep"
43
44         drop_request "tchmod 111 $f2" ||
45                 error_noexit "chmod '$f2': drop req"
46
47         drop_reint_reply "tchmod 666 $f2" ||
48                 error_noexit "chmod '$f2': drop rep"
49
50         drop_request "statone $f2" ||
51                 error_noexit "stat '$f2': drop req"
52
53         drop_reply  "statone $f2" ||
54                 error_noexit "stat '$f2': drop rep"
55 }
56 run_test 1 "create, chmod, stat: drop req, drop rep"
57
58 test_4() {
59         local t=$DIR/$tfile
60         do_facet_create_file client $t 10K ||
61                 error_noexit "Create file $t"
62
63         drop_request "cat $t > /dev/null" ||
64                 error_noexit "Open request for $t file"
65
66         drop_reply "cat $t > /dev/null" ||
67                 error_noexit "Open replay for $t file"
68 }
69 run_test 4 "open: drop req, drop rep"
70
71 test_5() {
72         local T=$DIR/$tfile
73         local R="$T-renamed"
74         local RR="$T-renamed-again"
75         do_facet_create_file client $T 10K ||
76                 error_noexit "Create file $T"
77
78         drop_request "mv $T $R" ||
79                 error_noexit "Rename $T"
80
81         drop_reint_reply "mv $R $RR" ||
82                 error_noexit "Failed rename replay on $R"
83
84         do_facet client "checkstat -v $RR" ||
85                 error_noexit "checkstat error on $RR"
86
87         do_facet client "rm $RR" ||
88                 error_noexit "Can't remove file $RR"
89 }
90 run_test 5 "rename: drop req, drop rep"
91
92 test_6() {
93         local T=$DIR/$tfile
94         local LINK1=$DIR/$tfile.link1
95         local LINK2=$DIR/$tfile.link2
96
97         do_facet_create_file client $T 10K ||
98                 error_noexit "Create file $T"
99
100         drop_request "mlink $T $LINK1" ||
101                 error_noexit "mlink request for $T"
102
103         drop_reint_reply "mlink $T $LINK2" ||
104                 error_noexit "mlink reply for $T"
105
106         drop_request "munlink $LINK1" ||
107                 error_noexit "munlink request for $T"
108
109         drop_reint_reply "munlink $LINK2" ||
110                 error_noexit "munlink reply for $T"
111
112         do_facet client "rm $T" ||
113                 error_noexit "Can't remove file $T"
114 }
115 run_test 6 "link, unlink: drop req, drop rep"
116
117 #bug 1423
118 test_8() {
119     drop_reint_reply "touch $DIR/$tfile"    || return 1
120 }
121 run_test 8 "touch: drop rep (bug 1423)"
122
123 #bug 1420
124 test_9() {
125         remote_ost_nodsh && skip "remote OST with nodsh" && return 0
126
127         local t1=${tfile}.1
128         local t2=${tfile}.2
129         do_facet_random_file client $TMP/$tfile 1K ||
130                 error_noexit "Create random file $TMP/$tfile"
131         # make this big, else test 9 doesn't wait for bulk -- bz 5595
132         do_facet_create_file client $TMP/$t1 4M ||
133                 error_noexit "Create file $TMP/$t1"
134         do_facet client "cp $TMP/$t1 $DIR/$t1" ||
135                 error_noexit "Can't copy to $DIR/$t1 file"
136         pause_bulk "cp $TMP/$tfile $DIR/$tfile" ||
137                 error_noexit "Can't pause_bulk copy"
138         do_facet client "cp $TMP/$t1 $DIR/$t2" ||
139                 error_noexit "Can't copy file"
140         do_facet client "sync"
141         do_facet client "rm $DIR/$tfile $DIR/$t2 $DIR/$t1" ||
142                 error_noexit "Can't remove files"
143         do_facet client "rm $TMP/$t1 $TMP/$tfile"
144 }
145 run_test 9 "pause bulk on OST (bug 1420)"
146
147 #bug 1521
148 test_10() {
149     do_facet client mcreate $DIR/$tfile        || return 1
150     drop_bl_callback "chmod 0777 $DIR/$tfile"  || echo "evicted as expected"
151     # wait for the mds to evict the client
152     #echo "sleep $(($TIMEOUT*2))"
153     #sleep $(($TIMEOUT*2))
154     do_facet client touch $DIR/$tfile || echo "touch failed, evicted"
155     do_facet client checkstat -v -p 0777 $DIR/$tfile  || return 3
156     do_facet client "munlink $DIR/$tfile"
157 }
158 run_test 10 "finish request on server after client eviction (bug 1521)"
159
160 #bug 2460
161 # wake up a thread waiting for completion after eviction
162 test_11(){
163     do_facet client $MULTIOP $DIR/$tfile Ow  || return 1
164     do_facet client $MULTIOP $DIR/$tfile or  || return 2
165
166     cancel_lru_locks osc
167
168     do_facet client $MULTIOP $DIR/$tfile or  || return 3
169     drop_bl_callback $MULTIOP $DIR/$tfile Ow || echo "evicted as expected"
170
171     do_facet client munlink $DIR/$tfile  || return 4
172 }
173 run_test 11 "wake up a thread waiting for completion after eviction (b=2460)"
174
175 #b=2494
176 test_12(){
177     $LCTL mark $MULTIOP $DIR/$tfile OS_c
178     do_facet $SINGLEMDS "lctl set_param fail_loc=0x115"
179     clear_failloc $SINGLEMDS $((TIMEOUT * 2)) &
180     multiop_bg_pause $DIR/$tfile OS_c || return 1
181     PID=$!
182 #define OBD_FAIL_MDS_CLOSE_NET           0x115
183     kill -USR1 $PID
184     echo "waiting for multiop $PID"
185     wait $PID || return 2
186     do_facet client munlink $DIR/$tfile  || return 3
187 }
188 run_test 12 "recover from timed out resend in ptlrpcd (b=2494)"
189
190 # Bug 113, check that readdir lost recv timeout works.
191 test_13() {
192     mkdir -p $DIR/$tdir || return 1
193     touch $DIR/$tdir/newentry || return
194 # OBD_FAIL_MDS_READPAGE_NET|OBD_FAIL_ONCE
195     do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000104"
196     ls $DIR/$tdir || return 3
197     do_facet $SINGLEMDS "lctl set_param fail_loc=0"
198     rm -rf $DIR/$tdir || return 4
199 }
200 run_test 13 "mdc_readpage restart test (bug 1138)"
201
202 # Bug 113, check that readdir lost send timeout works.
203 test_14() {
204     mkdir -p $DIR/$tdir
205     touch $DIR/$tdir/newentry
206 # OBD_FAIL_MDS_SENDPAGE|OBD_FAIL_ONCE
207     do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000106"
208     ls $DIR/$tdir || return 1
209     do_facet $SINGLEMDS "lctl set_param fail_loc=0"
210 }
211 run_test 14 "mdc_readpage resend test (bug 1138)"
212
213 test_15() {
214     do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000128"
215     touch $DIR/$tfile && return 1
216     return 0
217 }
218 run_test 15 "failed open (-ENOMEM)"
219
220 READ_AHEAD=`lctl get_param -n llite.*.max_read_ahead_mb | head -n 1`
221 stop_read_ahead() {
222    lctl set_param -n llite.*.max_read_ahead_mb 0
223 }
224
225 start_read_ahead() {
226    lctl set_param -n llite.*.max_read_ahead_mb $READ_AHEAD
227 }
228
229 test_16() {
230         remote_ost_nodsh && skip "remote OST with nodsh" && return 0
231
232         do_facet_random_file client $TMP/$tfile 100K ||
233                 { error_noexit "Create random file $TMP/$T" ; return 0; }
234         do_facet client "cp $TMP/$tfile $DIR/$tfile" ||
235                 { error_noexit "Copy to $DIR/$tfile file" ; return 0; }
236         sync
237         stop_read_ahead
238
239 #define OBD_FAIL_PTLRPC_BULK_PUT_NET 0x504 | OBD_FAIL_ONCE
240         do_facet ost1 "lctl set_param fail_loc=0x80000504"
241         cancel_lru_locks osc
242         # OST bulk will time out here, client resends
243         do_facet client "cmp $TMP/$tfile $DIR/$tfile" || return 1
244         do_facet ost1 lctl set_param fail_loc=0
245         # give recovery a chance to finish (shouldn't take long)
246         sleep $TIMEOUT
247         do_facet client "cmp $TMP/$tfile $DIR/$tfile" || return 2
248         start_read_ahead
249 }
250 run_test 16 "timeout bulk put, don't evict client (2732)"
251
252 test_17() {
253     local at_max_saved=0
254
255     remote_ost_nodsh && skip "remote OST with nodsh" && return 0
256
257         local SAMPLE_FILE=$TMP/$tfile
258         do_facet_random_file client $SAMPLE_FILE 20K ||
259                 { error_noexit "Create random file $SAMPLE_FILE" ; return 0; }
260
261     # With adaptive timeouts, bulk_get won't expire until adaptive_timeout_max
262     if at_is_enabled; then
263         at_max_saved=$(at_max_get ost1)
264         at_max_set $TIMEOUT ost1
265     fi
266
267     # OBD_FAIL_PTLRPC_BULK_GET_NET 0x0503 | OBD_FAIL_ONCE
268     # OST bulk will time out here, client retries
269     do_facet ost1 lctl set_param fail_loc=0x80000503
270     # need to ensure we send an RPC
271     do_facet client cp $SAMPLE_FILE $DIR/$tfile
272     sync
273
274     # with AT, client will wait adaptive_max*factor+net_latency before
275     # expiring the req, hopefully timeout*2 is enough
276     sleep $(($TIMEOUT*2))
277
278     do_facet ost1 lctl set_param fail_loc=0
279     do_facet client "df $DIR"
280     # expect cmp to succeed, client resent bulk
281     do_facet client "cmp $SAMPLE_FILE $DIR/$tfile" || return 3
282     do_facet client "rm $DIR/$tfile" || return 4
283     [ $at_max_saved -ne 0 ] && at_max_set $at_max_saved ost1
284     return 0
285 }
286 run_test 17 "timeout bulk get, don't evict client (2732)"
287
288 test_18a() {
289     [ -z ${ost2_svc} ] && skip_env "needs 2 osts" && return 0
290
291         do_facet_create_file client $TMP/$tfile 20K ||
292                 { error_noexit "Create file $TMP/$tfile" ; return 0; }
293
294     do_facet client mkdir -p $DIR/$tdir
295     f=$DIR/$tdir/$tfile
296
297     cancel_lru_locks osc
298     pgcache_empty || return 1
299
300     # 1 stripe on ost2
301     $LFS setstripe -i 1 -c 1 $f
302     stripe_index=$($LFS getstripe -i $f)
303     if [ $stripe_index -ne 1 ]; then
304         $LFS getstripe $f
305         error "$f: stripe_index $stripe_index != 1" && return
306     fi
307
308     do_facet client cp $TMP/$tfile $f
309     sync
310     local osc2dev=`lctl get_param -n devices | grep ${ost2_svc}-osc- | egrep -v 'MDT' | awk '{print $1}'`
311     $LCTL --device $osc2dev deactivate || return 3
312     # my understanding is that there should be nothing in the page
313     # cache after the client reconnects?     
314     rc=0
315     pgcache_empty || rc=2
316     $LCTL --device $osc2dev activate
317     rm -f $f
318     return $rc
319 }
320 run_test 18a "manual ost invalidate clears page cache immediately"
321
322 test_18b() {
323     remote_ost_nodsh && skip "remote OST with nodsh" && return 0
324
325         do_facet_create_file client $TMP/$tfile 20K ||
326                 { error_noexit "Create file $TMP/$tfile" ; return 0; }
327
328     do_facet client mkdir -p $DIR/$tdir
329     f=$DIR/$tdir/$tfile
330
331     cancel_lru_locks osc
332     pgcache_empty || return 1
333
334     $LFS setstripe -i 0 -c 1 $f
335     stripe_index=$($LFS getstripe -i $f)
336     if [ $stripe_index -ne 0 ]; then
337         $LFS getstripe $f
338         error "$f: stripe_index $stripe_index != 0" && return
339     fi
340
341     do_facet client cp $TMP/$tfile $f
342     sync
343     ost_evict_client
344     # allow recovery to complete
345     sleep $((TIMEOUT + 2))
346     # my understanding is that there should be nothing in the page
347     # cache after the client reconnects?     
348     rc=0
349     pgcache_empty || rc=2
350     rm -f $f
351     return $rc
352 }
353 run_test 18b "eviction and reconnect clears page cache (2766)"
354
355 test_18c() {
356     remote_ost_nodsh && skip "remote OST with nodsh" && return 0
357
358         do_facet_create_file client $TMP/$tfile 20K ||
359                 { error_noexit "Create file $TMP/$tfile" ; return 0; }
360
361     do_facet client mkdir -p $DIR/$tdir
362     f=$DIR/$tdir/$tfile
363
364     cancel_lru_locks osc
365     pgcache_empty || return 1
366
367     $LFS setstripe -i 0 -c 1 $f
368     stripe_index=$($LFS getstripe -i $f)
369     if [ $stripe_index -ne 0 ]; then
370         $LFS getstripe $f
371         error "$f: stripe_index $stripe_index != 0" && return
372     fi
373
374     do_facet client cp $TMP/$tfile $f
375     sync
376     ost_evict_client
377
378     # OBD_FAIL_OST_CONNECT_NET2
379     # lost reply to connect request
380     do_facet ost1 lctl set_param fail_loc=0x80000225
381     # force reconnect
382     sleep 1
383     df $MOUNT > /dev/null 2>&1
384     sleep 2
385     # my understanding is that there should be nothing in the page
386     # cache after the client reconnects?     
387     rc=0
388     pgcache_empty || rc=2
389     rm -f $f
390     return $rc
391 }
392 run_test 18c "Dropped connect reply after eviction handing (14755)"
393
394 test_19a() {
395         local BEFORE=`date +%s`
396         local EVICT
397
398         mount_client $DIR2
399
400         do_facet client mcreate $DIR/$tfile        || return 1
401         drop_ldlm_cancel "chmod 0777 $DIR2"
402
403         umount_client $DIR2
404         do_facet client "munlink $DIR/$tfile"
405
406         # let the client reconnect
407         sleep 5
408         EVICT=$(do_facet client $LCTL get_param mdc.$FSNAME-MDT*.state | \
409             awk -F"[ [,]" '/EVICTED]$/ { if (mx<$4) {mx=$4;} } END { print mx }')
410
411         [ ! -z "$EVICT" ] && [[ $EVICT -gt $BEFORE ]] || error "no eviction"
412 }
413 run_test 19a "test expired_lock_main on mds (2867)"
414
415 test_19b() {
416         local BEFORE=`date +%s`
417         local EVICT
418
419         mount_client $DIR2
420
421         do_facet client $MULTIOP $DIR/$tfile Ow  || return 1
422         drop_ldlm_cancel $MULTIOP $DIR2/$tfile Ow
423         umount_client $DIR2
424         do_facet client munlink $DIR/$tfile
425
426         # let the client reconnect
427         sleep 5
428         EVICT=$(do_facet client $LCTL get_param osc.$FSNAME-OST*.state | \
429             awk -F"[ [,]" '/EVICTED]$/ { if (mx<$4) {mx=$4;} } END { print mx }')
430
431         [ ! -z "$EVICT" ] && [[ $EVICT -gt $BEFORE ]] || error "no eviction"
432 }
433 run_test 19b "test expired_lock_main on ost (2867)"
434
435 test_20a() {    # bug 2983 - ldlm_handle_enqueue cleanup
436         remote_ost_nodsh && skip "remote OST with nodsh" && return 0
437
438         mkdir -p $DIR/$tdir
439         $LFS setstripe -i 0 -c 1 $DIR/$tdir/${tfile}
440         multiop_bg_pause $DIR/$tdir/${tfile} O_wc || return 1
441         MULTI_PID=$!
442         cancel_lru_locks osc
443 #define OBD_FAIL_LDLM_ENQUEUE_EXTENT_ERR 0x308
444         do_facet ost1 lctl set_param fail_loc=0x80000308
445         kill -USR1 $MULTI_PID
446         wait $MULTI_PID
447         rc=$?
448         [ $rc -eq 0 ] && error "multiop didn't fail enqueue: rc $rc" || true
449 }
450 run_test 20a "ldlm_handle_enqueue error (should return error)" 
451
452 test_20b() {    # bug 2986 - ldlm_handle_enqueue error during open
453         remote_ost_nodsh && skip "remote OST with nodsh" && return 0
454
455         mkdir -p $DIR/$tdir
456         $LFS setstripe -i 0 -c 1 $DIR/$tdir/${tfile}
457         cancel_lru_locks osc
458 #define OBD_FAIL_LDLM_ENQUEUE_EXTENT_ERR 0x308
459         do_facet ost1 lctl set_param fail_loc=0x80000308
460         dd if=/etc/hosts of=$DIR/$tdir/$tfile && \
461                 error "didn't fail open enqueue" || true
462 }
463 run_test 20b "ldlm_handle_enqueue error (should return error)"
464
465 test_21a() {
466        mkdir -p $DIR/$tdir-1
467        mkdir -p $DIR/$tdir-2
468        multiop_bg_pause $DIR/$tdir-1/f O_c || return 1
469        close_pid=$!
470
471        do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000129"
472        $MULTIOP $DIR/$tdir-2/f Oc &
473        open_pid=$!
474        sleep 1
475        do_facet $SINGLEMDS "lctl set_param fail_loc=0"
476
477        do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000115"
478        kill -USR1 $close_pid
479        cancel_lru_locks mdc
480        wait $close_pid || return 1
481        wait $open_pid || return 2
482        do_facet $SINGLEMDS "lctl set_param fail_loc=0"
483
484        $CHECKSTAT -t file $DIR/$tdir-1/f || return 3
485        $CHECKSTAT -t file $DIR/$tdir-2/f || return 4
486
487        rm -rf $DIR/$tdir-*
488 }
489 run_test 21a "drop close request while close and open are both in flight"
490
491 test_21b() {
492        mkdir -p $DIR/$tdir-1
493        mkdir -p $DIR/$tdir-2
494        multiop_bg_pause $DIR/$tdir-1/f O_c || return 1
495        close_pid=$!
496
497        do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000107"
498        mcreate $DIR/$tdir-2/f &
499        open_pid=$!
500        sleep 1
501        do_facet $SINGLEMDS "lctl set_param fail_loc=0"
502
503        kill -USR1 $close_pid
504        cancel_lru_locks mdc
505        wait $close_pid || return 1
506        wait $open_pid || return 3
507
508        $CHECKSTAT -t file $DIR/$tdir-1/f || return 4
509        $CHECKSTAT -t file $DIR/$tdir-2/f || return 5
510        rm -rf $DIR/$tdir-*
511 }
512 run_test 21b "drop open request while close and open are both in flight"
513
514 test_21c() {
515        mkdir -p $DIR/$tdir-1
516        mkdir -p $DIR/$tdir-2
517        multiop_bg_pause $DIR/$tdir-1/f O_c || return 1
518        close_pid=$!
519
520        do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000107"
521        mcreate $DIR/$tdir-2/f &
522        open_pid=$!
523        sleep 3
524        do_facet $SINGLEMDS "lctl set_param fail_loc=0"
525
526        do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000115"
527        kill -USR1 $close_pid
528        cancel_lru_locks mdc
529        wait $close_pid || return 1
530        wait $open_pid || return 2
531
532        do_facet $SINGLEMDS "lctl set_param fail_loc=0"
533
534        $CHECKSTAT -t file $DIR/$tdir-1/f || return 2
535        $CHECKSTAT -t file $DIR/$tdir-2/f || return 3
536        rm -rf $DIR/$tdir-*
537 }
538 run_test 21c "drop both request while close and open are both in flight"
539
540 test_21d() {
541        mkdir -p $DIR/$tdir-1
542        mkdir -p $DIR/$tdir-2
543        multiop_bg_pause $DIR/$tdir-1/f O_c || return 1
544        pid=$!
545
546        do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000129"
547        $MULTIOP $DIR/$tdir-2/f Oc &
548        sleep 1
549        do_facet $SINGLEMDS "lctl set_param fail_loc=0"
550
551        do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000122"
552        kill -USR1 $pid
553        cancel_lru_locks mdc
554        wait $pid || return 1
555        do_facet $SINGLEMDS "lctl set_param fail_loc=0"
556
557        $CHECKSTAT -t file $DIR/$tdir-1/f || return 2
558        $CHECKSTAT -t file $DIR/$tdir-2/f || return 3
559
560        rm -rf $DIR/$tdir-*
561 }
562 run_test 21d "drop close reply while close and open are both in flight"
563
564 test_21e() {
565        mkdir -p $DIR/$tdir-1
566        mkdir -p $DIR/$tdir-2
567        multiop_bg_pause $DIR/$tdir-1/f O_c || return 1
568        pid=$!
569
570        do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000119"
571        touch $DIR/$tdir-2/f &
572        sleep 1
573        do_facet $SINGLEMDS "lctl set_param fail_loc=0"
574
575        kill -USR1 $pid
576        cancel_lru_locks mdc
577        wait $pid || return 1
578
579        sleep $TIMEOUT
580        $CHECKSTAT -t file $DIR/$tdir-1/f || return 2
581        $CHECKSTAT -t file $DIR/$tdir-2/f || return 3
582        rm -rf $DIR/$tdir-*
583 }
584 run_test 21e "drop open reply while close and open are both in flight"
585
586 test_21f() {
587        mkdir -p $DIR/$tdir-1
588        mkdir -p $DIR/$tdir-2
589        multiop_bg_pause $DIR/$tdir-1/f O_c || return 1
590        pid=$!
591
592        do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000119"
593        touch $DIR/$tdir-2/f &
594        sleep 1
595        do_facet $SINGLEMDS "lctl set_param fail_loc=0"
596
597        do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000122"
598        kill -USR1 $pid
599        cancel_lru_locks mdc
600        wait $pid || return 1
601        do_facet $SINGLEMDS "lctl set_param fail_loc=0"
602
603        $CHECKSTAT -t file $DIR/$tdir-1/f || return 2
604        $CHECKSTAT -t file $DIR/$tdir-2/f || return 3
605        rm -rf $DIR/$tdir-*
606 }
607 run_test 21f "drop both reply while close and open are both in flight"
608
609 test_21g() {
610        mkdir -p $DIR/$tdir-1
611        mkdir -p $DIR/$tdir-2
612        multiop_bg_pause $DIR/$tdir-1/f O_c || return 1
613        pid=$!
614
615        do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000119"
616        touch $DIR/$tdir-2/f &
617        sleep 1
618        do_facet $SINGLEMDS "lctl set_param fail_loc=0"
619
620        do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000115"
621        kill -USR1 $pid
622        cancel_lru_locks mdc
623        wait $pid || return 1
624        do_facet $SINGLEMDS "lctl set_param fail_loc=0"
625
626        $CHECKSTAT -t file $DIR/$tdir-1/f || return 2
627        $CHECKSTAT -t file $DIR/$tdir-2/f || return 3
628        rm -rf $DIR/$tdir-*
629 }
630 run_test 21g "drop open reply and close request while close and open are both in flight"
631
632 test_21h() {
633        mkdir -p $DIR/$tdir-1
634        mkdir -p $DIR/$tdir-2
635        multiop_bg_pause $DIR/$tdir-1/f O_c || return 1
636        pid=$!
637
638        do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000107"
639        touch $DIR/$tdir-2/f &
640        touch_pid=$!
641        sleep 1
642        do_facet $SINGLEMDS "lctl set_param fail_loc=0"
643
644        do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000122"
645        cancel_lru_locks mdc
646        kill -USR1 $pid
647        wait $pid || return 1
648        do_facet $SINGLEMDS "lctl set_param fail_loc=0"
649
650        wait $touch_pid || return 2
651
652        $CHECKSTAT -t file $DIR/$tdir-1/f || return 3
653        $CHECKSTAT -t file $DIR/$tdir-2/f || return 4
654        rm -rf $DIR/$tdir-*
655 }
656 run_test 21h "drop open request and close reply while close and open are both in flight"
657
658 # bug 3462 - multiple MDC requests
659 test_22() {
660     f1=$DIR/${tfile}-1
661     f2=$DIR/${tfile}-2
662     
663     do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000115"
664     $MULTIOP $f2 Oc &
665     close_pid=$!
666
667     sleep 1
668     $MULTIOP $f1 msu || return 1
669
670     cancel_lru_locks mdc
671     do_facet $SINGLEMDS "lctl set_param fail_loc=0"
672
673     wait $close_pid || return 2
674     rm -rf $f2 || return 4
675 }
676 run_test 22 "drop close request and do mknod"
677
678 test_23() { #b=4561
679     multiop_bg_pause $DIR/$tfile O_c || return 1
680     pid=$!
681     # give a chance for open
682     sleep 5
683
684     # try the close
685     drop_request "kill -USR1 $pid"
686
687     fail $SINGLEMDS
688     wait $pid || return 1
689     return 0
690 }
691 run_test 23 "client hang when close a file after mds crash"
692
693 test_24a() { # bug 11710 details correct fsync() behavior
694         remote_ost_nodsh && skip "remote OST with nodsh" && return 0
695
696         mkdir -p $DIR/$tdir
697         $LFS setstripe -i 0 -c 1 $DIR/$tdir
698         cancel_lru_locks osc
699         multiop_bg_pause $DIR/$tdir/$tfile Owy_wyc || return 1
700         MULTI_PID=$!
701         ost_evict_client
702         kill -USR1 $MULTI_PID
703         wait $MULTI_PID
704         rc=$?
705         lctl set_param fail_loc=0x0
706         client_reconnect
707         [ $rc -eq 0 ] && error_ignore 5494 "multiop didn't fail fsync: rc $rc" || true
708 }
709 run_test 24a "fsync error (should return error)"
710
711 wait_client_evicted () {
712         local facet=$1
713         local exports=$2
714         local varsvc=${facet}_svc
715
716         wait_update $(facet_active_host $facet) \
717                 "lctl get_param -n *.${!varsvc}.num_exports | cut -d' ' -f2" \
718                 $((exports - 1)) $3
719 }
720
721 test_24b() {
722         remote_ost_nodsh && skip "remote OST with nodsh" && return 0
723
724         dmesg -c
725         mkdir -p $DIR/$tdir
726         lfs setstripe $DIR/$tdir -s 0 -i 0 -c 1
727         cancel_lru_locks osc
728         multiop_bg_pause $DIR/$tdir/$tfile-1 Ow8192_yc ||
729                 error "mulitop Ow8192_yc failed"
730
731         MULTI_PID1=$!
732         multiop_bg_pause $DIR/$tdir/$tfile-2 Ow8192_c ||
733                 error "mulitop Ow8192_c failed"
734
735         MULTI_PID2=$!
736         ost_evict_client
737
738         kill -USR1 $MULTI_PID1
739         wait $MULTI_PID1
740         rc1=$?
741         kill -USR1 $MULTI_PID2
742         wait $MULTI_PID2
743         rc2=$?
744         lctl set_param fail_loc=0x0
745         client_reconnect
746         [ $rc1 -eq 0 -o $rc2 -eq 0 ] &&
747         error_ignore "multiop didn't fail fsync: $rc1 or close: $rc2" || true
748
749         dmesg | grep "dirty page discard:" || \
750                 error "no discarded dirty page found!"
751 }
752 run_test 24b "test dirty page discard due to client eviction"
753
754 test_26a() {      # was test_26 bug 5921 - evict dead exports by pinger
755 # this test can only run from a client on a separate node.
756         remote_ost || { skip "local OST" && return 0; }
757         remote_ost_nodsh && skip "remote OST with nodsh" && return 0
758         remote_mds || { skip "local MDS" && return 0; }
759
760         if [ $(facet_host mgs) = $(facet_host ost1) ]; then
761                 skip "msg and ost1 are at the same node"
762                 return 0
763         fi
764
765         check_timeout || return 1
766
767         local OST_NEXP=$(do_facet ost1 lctl get_param -n obdfilter.${ost1_svc}.num_exports | cut -d' ' -f2)
768
769         echo starting with $OST_NEXP OST exports
770 # OBD_FAIL_PTLRPC_DROP_RPC 0x505
771         do_facet client lctl set_param fail_loc=0x505
772         # evictor takes PING_EVICT_TIMEOUT + 3 * PING_INTERVAL to evict.
773         # But if there's a race to start the evictor from various obds,
774         # the loser might have to wait for the next ping.
775
776         local rc=0
777         wait_client_evicted ost1 $OST_NEXP $((TIMEOUT * 2 + TIMEOUT * 3 / 4))
778         rc=$?
779         do_facet client lctl set_param fail_loc=0x0
780         [ $rc -eq 0 ] || error "client not evicted from OST"
781 }
782 run_test 26a "evict dead exports"
783
784 test_26b() {      # bug 10140 - evict dead exports by pinger
785         remote_ost_nodsh && skip "remote OST with nodsh" && return 0
786
787         if [ $(facet_host mgs) = $(facet_host ost1) ]; then
788                 skip "msg and ost1 are at the same node"
789                 return 0
790         fi
791
792         check_timeout || return 1
793         clients_up
794         zconf_mount `hostname` $MOUNT2 ||
795                 { error "Failed to mount $MOUNT2"; return 2; }
796         sleep 1 # wait connections being established
797
798         local MDS_NEXP=$(do_facet $SINGLEMDS lctl get_param -n mdt.${mds1_svc}.num_exports | cut -d' ' -f2)
799         local OST_NEXP=$(do_facet ost1 lctl get_param -n obdfilter.${ost1_svc}.num_exports | cut -d' ' -f2)
800
801         echo starting with $OST_NEXP OST and $MDS_NEXP MDS exports
802
803         zconf_umount `hostname` $MOUNT2 -f
804
805         # PING_INTERVAL max(obd_timeout / 4, 1U)
806         # PING_EVICT_TIMEOUT (PING_INTERVAL * 6)
807
808         # evictor takes PING_EVICT_TIMEOUT + 3 * PING_INTERVAL to evict.  
809         # But if there's a race to start the evictor from various obds, 
810         # the loser might have to wait for the next ping.
811         # = 9 * PING_INTERVAL + PING_INTERVAL
812         # = 10 PING_INTERVAL = 10 obd_timeout / 4 = 2.5 obd_timeout
813         # let's wait $((TIMEOUT * 3)) # bug 19887
814         local rc=0
815         wait_client_evicted ost1 $OST_NEXP $((TIMEOUT * 3)) || \
816                 error "Client was not evicted by ost" rc=1
817         wait_client_evicted $SINGLEMDS $MDS_NEXP $((TIMEOUT * 3)) || \
818                 error "Client was not evicted by mds"
819 }
820 run_test 26b "evict dead exports"
821
822 test_27() {
823         mkdir -p $DIR/$tdir
824         writemany -q -a $DIR/$tdir/$tfile 0 5 &
825         CLIENT_PID=$!
826         sleep 1
827         local save_FAILURE_MODE=$FAILURE_MODE
828         FAILURE_MODE="SOFT"
829         facet_failover $SINGLEMDS
830 #define OBD_FAIL_OSC_SHUTDOWN            0x407
831         do_facet $SINGLEMDS lctl set_param fail_loc=0x80000407
832         # need to wait for reconnect
833         echo waiting for fail_loc
834         wait_update_facet $SINGLEMDS "lctl get_param -n fail_loc" "-2147482617"
835         facet_failover $SINGLEMDS
836         #no crashes allowed!
837         kill -USR1 $CLIENT_PID
838         wait $CLIENT_PID 
839         true
840         FAILURE_MODE=$save_FAILURE_MODE
841 }
842 run_test 27 "fail LOV while using OSC's"
843
844 test_28() {      # bug 6086 - error adding new clients
845         do_facet client mcreate $DIR/$tfile       || return 1
846         drop_bl_callback "chmod 0777 $DIR/$tfile" ||echo "evicted as expected"
847         #define OBD_FAIL_MDS_CLIENT_ADD 0x12f
848         do_facet $SINGLEMDS "lctl set_param fail_loc=0x8000012f"
849         # fail once (evicted), reconnect fail (fail_loc), ok
850         client_up || (sleep 10; client_up) || (sleep 10; client_up) || error "reconnect failed"
851         rm -f $DIR/$tfile
852         fail $SINGLEMDS         # verify MDS last_rcvd can be loaded
853 }
854 run_test 28 "handle error adding new clients (bug 6086)"
855
856 test_29a() { # bug 22273 - error adding new clients
857         #define OBD_FAIL_TGT_CLIENT_ADD 0x711
858         do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000711"
859         # fail abort so client will be new again
860         fail_abort $SINGLEMDS
861         client_up || error "reconnect failed"
862         return 0
863 }
864 run_test 29a "error adding new clients doesn't cause LBUG (bug 22273)"
865
866 test_29b() { # bug 22273 - error adding new clients
867         #define OBD_FAIL_TGT_CLIENT_ADD 0x711
868         do_facet ost1 "lctl set_param fail_loc=0x80000711"
869         # fail abort so client will be new again
870         fail_abort ost1
871         client_up || error "reconnect failed"
872         return 0
873 }
874 run_test 29b "error adding new clients doesn't cause LBUG (bug 22273)"
875
876 test_50() {
877         mkdir -p $DIR/$tdir
878         # put a load of file creates/writes/deletes
879         writemany -q $DIR/$tdir/$tfile 0 5 &
880         CLIENT_PID=$!
881         echo writemany pid $CLIENT_PID
882         sleep 10
883         FAILURE_MODE="SOFT"
884         fail $SINGLEMDS
885         # wait for client to reconnect to MDS
886         sleep 60
887         fail $SINGLEMDS
888         sleep 60
889         fail $SINGLEMDS
890         # client process should see no problems even though MDS went down
891         sleep $TIMEOUT
892         kill -USR1 $CLIENT_PID
893         wait $CLIENT_PID 
894         rc=$?
895         echo writemany returned $rc
896         #these may fail because of eviction due to slow AST response.
897         [ $rc -eq 0 ] || error_ignore 13652 "writemany returned rc $rc" || true
898 }
899 run_test 50 "failover MDS under load"
900
901 test_51() {
902         #define OBD_FAIL_MDS_SYNC_CAPA_SL                    0x1310
903         do_facet ost1 lctl set_param fail_loc=0x00001310
904
905         mkdir -p $DIR/$tdir
906         # put a load of file creates/writes/deletes
907         writemany -q $DIR/$tdir/$tfile 0 5 &
908         CLIENT_PID=$!
909         sleep 1
910         FAILURE_MODE="SOFT"
911         facet_failover $SINGLEMDS
912         # failover at various points during recovery
913         SEQ="1 5 10 $(seq $TIMEOUT 5 $(($TIMEOUT+10)))"
914         echo will failover at $SEQ
915         for i in $SEQ
916           do
917           echo failover in $i sec
918           sleep $i
919           facet_failover $SINGLEMDS
920         done
921         # client process should see no problems even though MDS went down
922         # and recovery was interrupted
923         sleep $TIMEOUT
924         kill -USR1 $CLIENT_PID
925         wait $CLIENT_PID 
926         rc=$?
927         echo writemany returned $rc
928         [ $rc -eq 0 ] || error_ignore 13652 "writemany returned rc $rc" || true
929 }
930 run_test 51 "failover MDS during recovery"
931
932 test_52_guts() {
933         do_facet client "mkdir -p $DIR/$tdir"
934         do_facet client "writemany -q -a $DIR/$tdir/$tfile 300 5" &
935         CLIENT_PID=$!
936         echo writemany pid $CLIENT_PID
937         sleep 10
938         FAILURE_MODE="SOFT"
939         fail ost1
940         rc=0
941         wait $CLIENT_PID || rc=$?
942         # active client process should see an EIO for down OST
943         [ $rc -eq 5 ] && { echo "writemany correctly failed $rc" && return 0; }
944         # but timing or failover setup may allow success
945         [ $rc -eq 0 ] && { echo "writemany succeeded" && return 0; }
946         echo "writemany returned $rc"
947         return $rc
948 }
949
950 test_52() {
951         remote_ost_nodsh && skip "remote OST with nodsh" && return 0
952
953         mkdir -p $DIR/$tdir
954         test_52_guts
955         rc=$?
956         [ $rc -ne 0 ] && { return $rc; }
957         # wait for client to reconnect to OST
958         sleep 30
959         test_52_guts
960         rc=$?
961         [ $rc -ne 0 ] && { return $rc; }
962         sleep 30
963         test_52_guts
964         rc=$?
965         client_reconnect
966         #return $rc
967 }
968 run_test 52 "failover OST under load"
969
970 # test of open reconstruct
971 test_53() {
972         touch $DIR/$tfile
973         drop_ldlm_reply "openfile -f O_RDWR:O_CREAT -m 0755 $DIR/$tfile" ||\
974                 return 2
975 }
976 run_test 53 "touch: drop rep"
977
978 test_54() {
979         zconf_mount `hostname` $MOUNT2
980         touch $DIR/$tfile
981         touch $DIR2/$tfile.1
982         sleep 10
983         cat $DIR2/$tfile.missing # save transno = 0, rc != 0 into last_rcvd
984         fail $SINGLEMDS
985         umount $MOUNT2
986         ERROR=`dmesg | egrep "(test 54|went back in time)" | tail -n1 | grep "went back in time"`
987         [ x"$ERROR" == x ] || error "back in time occured"
988 }
989 run_test 54 "back in time"
990
991 # bug 11330 - liblustre application death during I/O locks up OST
992 test_55() {
993         remote_ost_nodsh && skip "remote OST with nodsh" && return 0
994
995         mkdir -p $DIR/$tdir
996
997         # first dd should be finished quickly
998         $LFS setstripe -c 1 -i 0 $DIR/$tdir/$tfile-1
999         dd if=/dev/zero of=$DIR/$tdir/$tfile-1 bs=32M count=4  &
1000         DDPID=$!
1001         count=0
1002         echo  "step1: testing ......"
1003         while [ true ]; do
1004             if [ -z `ps x | awk '$1 == '$DDPID' { print $5 }'` ]; then break; fi
1005             count=$[count+1]
1006             if [ $count -gt 64 ]; then
1007                 error "dd should be finished!"
1008             fi
1009             sleep 1
1010         done    
1011         echo "(dd_pid=$DDPID, time=$count)successful"
1012
1013         $LFS setstripe -c 1 -i 0 $DIR/$tdir/$tfile-2
1014         #define OBD_FAIL_OST_DROP_REQ            0x21d
1015         do_facet ost1 lctl set_param fail_loc=0x0000021d
1016         # second dd will be never finished
1017         dd if=/dev/zero of=$DIR/$tdir/$tfile-2 bs=32M count=4  &        
1018         DDPID=$!
1019         count=0
1020         echo  "step2: testing ......"
1021         while [ $count -le 64 ]; do
1022             dd_name="`ps x | awk '$1 == '$DDPID' { print $5 }'`"            
1023             if [ -z  $dd_name ]; then 
1024                 ls -l $DIR/$tdir
1025                 echo  "debug: (dd_name=$dd_name, dd_pid=$DDPID, time=$count)"
1026                 error "dd shouldn't be finished!"
1027             fi
1028             count=$[count+1]
1029             sleep 1
1030         done    
1031         echo "(dd_pid=$DDPID, time=$count)successful"
1032
1033         #Recover fail_loc and dd will finish soon
1034         do_facet ost1 lctl set_param fail_loc=0
1035         count=0
1036         echo  "step3: testing ......"
1037         while [ true ]; do
1038             if [ -z `ps x | awk '$1 == '$DDPID' { print $5 }'` ]; then break; fi
1039             count=$[count+1]
1040             if [ $count -gt 500 ]; then
1041                 error "dd should be finished!"
1042             fi
1043             sleep 1
1044         done    
1045         echo "(dd_pid=$DDPID, time=$count)successful"
1046
1047         rm -rf $DIR/$tdir
1048 }
1049 run_test 55 "ost_brw_read/write drops timed-out read/write request"
1050
1051 test_56() { # b=11277
1052 #define OBD_FAIL_MDS_RESEND      0x136
1053         touch $DIR/$tfile
1054         do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000136"
1055         stat $DIR/$tfile
1056         do_facet $SINGLEMDS "lctl set_param fail_loc=0"
1057         rm -f $DIR/$tfile
1058 }
1059 run_test 56 "do not allow reconnect to busy exports"
1060
1061 test_57_helper() {
1062         # no oscs means no client or mdt 
1063         while lctl get_param osc.*.* > /dev/null 2>&1; do
1064                 : # loop until proc file is removed
1065         done
1066 }
1067
1068 test_57() { # bug 10866
1069         test_57_helper &
1070         pid=$!
1071         sleep 1
1072 #define OBD_FAIL_LPROC_REMOVE            0xB00
1073         lctl set_param fail_loc=0x80000B00
1074         zconf_umount `hostname` $DIR
1075         lctl set_param fail_loc=0x80000B00
1076         fail_abort $SINGLEMDS
1077         kill -9 $pid
1078         lctl set_param fail_loc=0
1079         mount_client $DIR
1080         do_facet client "df $DIR"
1081 }
1082 run_test 57 "read procfs entries causes kernel crash"
1083
1084 test_58() { # bug 11546
1085 #define OBD_FAIL_MDC_ENQUEUE_PAUSE        0x801
1086         touch $DIR/$tfile
1087         ls -la $DIR/$tfile
1088         lctl set_param fail_loc=0x80000801
1089         cp $DIR/$tfile /dev/null &
1090         pid=$!
1091         sleep 1
1092         lctl set_param fail_loc=0
1093         drop_bl_callback rm -f $DIR/$tfile
1094         wait $pid
1095         # the first 'df' could tigger the eviction caused by
1096         # 'drop_bl_callback', and it's normal case.
1097         # but the next 'df' should return successfully.
1098         do_facet client "df $DIR" || do_facet client "df $DIR"
1099 }
1100 run_test 58 "Eviction in the middle of open RPC reply processing"
1101
1102 test_59() { # bug 10589
1103         zconf_mount `hostname` $MOUNT2 || error "Failed to mount $MOUNT2"
1104         echo $DIR2 | grep -q $MOUNT2 || error "DIR2 is not set properly: $DIR2"
1105 #define OBD_FAIL_LDLM_CANCEL_EVICT_RACE  0x311
1106         lctl set_param fail_loc=0x311
1107         writes=$(LANG=C dd if=/dev/zero of=$DIR2/$tfile count=1 2>&1)
1108         [ $? = 0 ] || error "dd write failed"
1109         writes=$(echo $writes | awk  -F '+' '/out/ {print $1}')
1110         lctl set_param fail_loc=0
1111         sync
1112         zconf_umount `hostname` $MOUNT2 -f
1113         reads=$(LANG=C dd if=$DIR/$tfile of=/dev/null 2>&1)
1114         [ $? = 0 ] || error "dd read failed"
1115         reads=$(echo $reads | awk -F '+' '/in/ {print $1}')
1116         [ "$reads" -eq "$writes" ] || error "read" $reads "blocks, must be" $writes
1117 }
1118 run_test 59 "Read cancel race on client eviction"
1119
1120 err17935 () {
1121     # we assume that all md changes are in the MDT0 changelog
1122     if [ $MDSCOUNT -gt 1 ]; then
1123         error_ignore 17935 $*
1124     else
1125         error $*
1126     fi
1127 }
1128
1129 test_60() {
1130         MDT0=$($LCTL get_param -n mdc.*.mds_server_uuid | \
1131             awk '{gsub(/_UUID/,""); print $1}' | head -1)
1132
1133         NUM_FILES=15000
1134         mkdir -p $DIR/$tdir
1135
1136         # Register (and start) changelog
1137         USER=$(do_facet $SINGLEMDS lctl --device $MDT0 changelog_register -n)
1138         echo "Registered as $MDT0 changelog user $USER"
1139
1140         # Generate a large number of changelog entries
1141         createmany -o $DIR/$tdir/$tfile $NUM_FILES
1142         sync
1143         sleep 5
1144
1145         # Unlink files in the background
1146         unlinkmany $DIR/$tdir/$tfile $NUM_FILES &
1147         CLIENT_PID=$!
1148         sleep 1
1149
1150         # Failover the MDS while unlinks are happening
1151         facet_failover $SINGLEMDS
1152
1153         # Wait for unlinkmany to finish
1154         wait $CLIENT_PID
1155
1156         # Check if all the create/unlink events were recorded
1157         # in the changelog
1158         $LFS changelog $MDT0 >> $DIR/$tdir/changelog
1159         local cl_count=$(grep UNLNK $DIR/$tdir/changelog | wc -l)
1160         echo "$cl_count unlinks in $MDT0 changelog"
1161
1162         do_facet $SINGLEMDS lctl --device $MDT0 changelog_deregister $USER
1163         USERS=$(( $(do_facet $SINGLEMDS lctl get_param -n \
1164             mdd.$MDT0.changelog_users | wc -l) - 2 ))
1165         if [ $USERS -eq 0 ]; then
1166             [ $cl_count -eq $NUM_FILES ] || \
1167                 err17935 "Recorded ${cl_count} unlinks out of $NUM_FILES"
1168             # Also make sure we can clear large changelogs
1169             cl_count=$($LFS changelog $FSNAME | wc -l)
1170             [ $cl_count -le 2 ] || \
1171                 error "Changelog not empty: $cl_count entries"
1172         else
1173             # If there are other users, there may be other unlinks in the log
1174             [ $cl_count -ge $NUM_FILES ] || \
1175                 err17935 "Recorded ${cl_count} unlinks out of $NUM_FILES"
1176             echo "$USERS other changelog users; can't verify clear"
1177         fi
1178 }
1179 run_test 60 "Add Changelog entries during MDS failover"
1180
1181 test_61()
1182 {
1183         local mdtosc=$(get_mdtosc_proc_path $SINGLEMDS $FSNAME-OST0000)
1184         mdtosc=${mdtosc/-MDT*/-MDT\*}
1185         local cflags="osc.$mdtosc.connect_flags"
1186         do_facet $SINGLEMDS "lctl get_param -n $cflags" |grep -q skip_orphan
1187         [ $? -ne 0 ] && skip "don't have skip orphan feature" && return
1188
1189         mkdir -p $DIR/$tdir || error "mkdir dir $DIR/$tdir failed"
1190         # Set the default stripe of $DIR/$tdir to put the files to ost1
1191         $LFS setstripe -c 1 -i 0 $DIR/$tdir
1192
1193         replay_barrier $SINGLEMDS
1194         createmany -o $DIR/$tdir/$tfile-%d 10 
1195         local oid=`do_facet ost1 "lctl get_param -n obdfilter.${ost1_svc}.last_id"`
1196
1197         fail_abort $SINGLEMDS
1198         
1199         touch $DIR/$tdir/$tfile
1200         local id=`$LFS getstripe $DIR/$tdir/$tfile | awk '$1 == 0 { print $2 }'`
1201         [ $id -le $oid ] && error "the orphan objid was reused, failed"
1202
1203         # Cleanup
1204         rm -rf $DIR/$tdir
1205 }
1206 run_test 61 "Verify to not reuse orphan objects - bug 17025"
1207
1208 check_cli_ir_state()
1209 {
1210         local NODE=${1:-$HOSTNAME}
1211         local st
1212         st=$(do_node $NODE "lctl get_param mgc.*.ir_state |
1213                             awk '/imperative_recovery:/ { print \\\$2}'")
1214         [ $st != ON -o $st != OFF -o $st != ENABLED -o $st != DISABLED ] ||
1215                 error "Error state $st, must be ENABLED or DISABLED"
1216         echo -n $st
1217 }
1218
1219 check_target_ir_state()
1220 {
1221         local target=${1}
1222         local name=${target}_svc
1223         local recovery_proc=obdfilter.${!name}.recovery_status
1224         local st
1225
1226         st=$(do_facet $target "lctl get_param -n $recovery_proc |
1227                                awk '/IR:/{ print \\\$2}'")
1228         [ $st != ON -o $st != OFF -o $st != ENABLED -o $st != DISABLED ] ||
1229                 error "Error state $st, must be ENABLED or DISABLED"
1230         echo -n $st
1231 }
1232
1233 set_ir_status()
1234 {
1235         do_facet mgs lctl set_param -n mgs.MGS.live.$FSNAME="state=$1"
1236 }
1237
1238 get_ir_status()
1239 {
1240         local state=$(do_facet mgs "lctl get_param -n mgs.MGS.live.$FSNAME |
1241                                     awk '/state:/{ print \\\$2 }'")
1242         echo -n ${state/,/}
1243 }
1244
1245 nidtbl_version_mgs()
1246 {
1247         local ver=$(do_facet mgs "lctl get_param -n mgs.MGS.live.$FSNAME |
1248                                   awk '/nidtbl_version:/{ print \\\$2 }'")
1249         echo -n $ver
1250 }
1251
1252 # nidtbl_version_client <mds1|client> [node]
1253 nidtbl_version_client()
1254 {
1255         local cli=$1
1256         local node=${2:-$HOSTNAME}
1257
1258         if [ X$cli = Xclient ]; then
1259                 cli=$FSNAME-client
1260         else
1261                 local obdtype=${cli/%[0-9]*/}
1262                 [ $obdtype != mds ] && error "wrong parameters $cli"
1263
1264                 node=$(facet_active_host $cli)
1265                 local t=${cli}_svc
1266                 cli=${!t}
1267         fi
1268
1269         local vers=$(do_node $node "lctl get_param -n mgc.*.ir_state" |
1270                      awk "/$cli/{print \$6}" |sort -u)
1271
1272         # in case there are multiple mounts on the client node
1273         local arr=($vers)
1274         [ ${#arr[@]} -ne 1 ] && error "versions on client node mismatch"
1275         echo -n $vers
1276 }
1277
1278 nidtbl_versions_match()
1279 {
1280         [ $(nidtbl_version_mgs) -eq $(nidtbl_version_client ${1:-client}) ]
1281 }
1282
1283 target_instance_match()
1284 {
1285         local srv=$1
1286         local obdtype
1287         local cliname
1288
1289         obdtype=${srv/%[0-9]*/}
1290         case $obdtype in
1291         mds)
1292                 obdname="mdt"
1293                 cliname="mdc"
1294                 ;;
1295         ost)
1296                 obdname="obdfilter"
1297                 cliname="osc"
1298                 ;;
1299         *)
1300                 error "invalid target type" $srv
1301                 return 1
1302                 ;;
1303         esac
1304
1305         local target=${srv}_svc
1306         local si=$(do_facet $srv lctl get_param -n $obdname.${!target}.instance)
1307         local ci=$(lctl get_param -n $cliname.${!target}-${cliname}-*.import | \
1308                   awk '/instance/{ print $2 }' |head -1)
1309
1310         return $([ $si -eq $ci ])
1311 }
1312
1313 test_100()
1314 {
1315         do_facet mgs $LCTL list_param mgs.*.ir_timeout ||
1316                 { skip "MGS without IR support"; return 0; }
1317
1318         # MDT was just restarted in the previous test, make sure everything
1319         # is all set.
1320         local cnt=30
1321         while [ $cnt -gt 0 ]; do
1322                 nidtbl_versions_match && break
1323                 sleep 1
1324                 cnt=$((cnt - 1))
1325         done
1326
1327         # disable IR
1328         set_ir_status disabled
1329
1330         local prev_ver=$(nidtbl_version_client client)
1331
1332         local saved_FAILURE_MODE=$FAILURE_MODE
1333         [ $(facet_host mgs) = $(facet_host ost1) ] && FAILURE_MODE="SOFT"
1334         fail ost1
1335
1336         # valid check
1337         [ $(nidtbl_version_client client) -eq $prev_ver ] ||
1338                 error "version must not change due to IR disabled"
1339         target_instance_match ost1 || error "instance mismatch"
1340
1341         # restore env
1342         set_ir_status full
1343         FAILURE_MODE=$saved_FAILURE_MODE
1344 }
1345 run_test 100 "IR: Make sure normal recovery still works w/o IR"
1346
1347 test_101()
1348 {
1349         do_facet mgs $LCTL list_param mgs.*.ir_timeout ||
1350                 { skip "MGS without IR support"; return 0; }
1351
1352         set_ir_status full
1353
1354         local OST1_IMP=$(get_osc_import_name client ost1)
1355
1356         # disable pinger recovery
1357         lctl set_param -n osc.$OST1_IMP.pinger_recov=0
1358
1359         fail ost1
1360
1361         target_instance_match ost1 || error "instance mismatch"
1362         nidtbl_versions_match || error "version must match"
1363
1364         lctl set_param -n osc.$OST1_IMP.pinger_recov=1
1365 }
1366 run_test 101 "IR: Make sure IR works w/o normal recovery"
1367
1368 test_102()
1369 {
1370         do_facet mgs $LCTL list_param mgs.*.ir_timeout ||
1371                 { skip "MGS without IR support"; return 0; }
1372
1373         local clients=${CLIENTS:-$HOSTNAME}
1374         local old_version
1375         local new_version
1376         local mgsdev=mgs
1377
1378         set_ir_status full
1379
1380         # let's have a new nidtbl version
1381         fail ost1
1382
1383         # sleep for a while so that clients can see the failure of ost
1384         # it must be MGC_TIMEOUT_MIN_SECONDS + MGC_TIMEOUT_RAND_CENTISEC.
1385         # int mgc_request.c:
1386         # define MGC_TIMEOUT_MIN_SECONDS   5
1387         # define MGC_TIMEOUT_RAND_CENTISEC 0x1ff /* ~500 *
1388         local count=30  # 20 seconds at most
1389         while [ $count -gt 0 ]; do
1390                 nidtbl_versions_match && break
1391                 sleep 1
1392                 count=$((count-1))
1393         done
1394
1395         nidtbl_versions_match || error "nidtbl mismatch"
1396
1397         # get the version #
1398         old_version=$(nidtbl_version_client client)
1399
1400         zconf_umount_clients $clients $MOUNT || error "Cannot umount client"
1401
1402         # restart mgs
1403         combined_mgs_mds && mgsdev=mds1
1404         remount_facet $mgsdev
1405         fail ost1
1406
1407         zconf_mount_clients $clients $MOUNT || error "Cannot mount client"
1408
1409         # check new version
1410         new_version=$(nidtbl_version_client client)
1411         [ $new_version -lt $old_version ] &&
1412                 error "nidtbl version wrong after mgs restarts"
1413         return 0
1414 }
1415 run_test 102 "IR: New client gets updated nidtbl after MGS restart"
1416
1417 test_103()
1418 {
1419         do_facet mgs $LCTL list_param mgs.*.ir_timeout ||
1420                 { skip "MGS without IR support"; return 0; }
1421
1422         combined_mgs_mds && skip "mgs and mds on the same target" && return 0
1423
1424         # workaround solution to generate config log on the mds
1425         remount_facet mds1
1426
1427         stop mgs
1428         stop mds1
1429
1430         # We need this test because mds is like a client in IR context.
1431         start mds1 $MDSDEV1 || error "MDS should start w/o mgs"
1432
1433         # start mgs and remount mds w/ ir
1434         start mgs $MGSDEV
1435         clients_up
1436
1437         # remount client so that fsdb will be created on the MGS
1438         umount_client $MOUNT || error "umount failed"
1439         mount_client $MOUNT || error "mount failed"
1440
1441         # sleep 30 seconds so the MDS has a chance to detect MGS restarting
1442         local count=30
1443         while [ $count -gt 0 ]; do
1444                 [ $(nidtbl_version_client mds1) -ne 0 ] && break
1445                 sleep 1
1446                 count=$((count-1))
1447         done
1448
1449         # after a while, mds should be able to reconnect to mgs and fetch
1450         # up-to-date nidtbl version
1451         nidtbl_versions_match mds1 || error "mds nidtbl mismatch"
1452
1453         # reset everything
1454         set_ir_status full
1455 }
1456 run_test 103 "IR: MDS can start w/o MGS and get updated nidtbl later"
1457
1458 test_104()
1459 {
1460         do_facet mgs $LCTL list_param mgs.*.ir_timeout ||
1461                 { skip "MGS without IR support"; return 0; }
1462
1463         set_ir_status full
1464
1465         stop ost1
1466         start ost1 $(ostdevname 1) "$OST_MOUNT_OPTS -onoir" ||
1467                 error "OST1 cannot start"
1468         clients_up
1469
1470         local ir_state=$(check_target_ir_state ost1)
1471         [ $ir_state = "DISABLED" -o $ir_state = "OFF" ] ||
1472                 error "ir status on ost1 should be DISABLED"
1473 }
1474 run_test 104 "IR: ost can disable IR voluntarily"
1475
1476 test_105()
1477 {
1478         [ -z "$RCLIENTS" ] && skip "Needs multiple clients" && return 0
1479         do_facet mgs $LCTL list_param mgs.*.ir_timeout ||
1480                 { skip "MGS without IR support"; return 0; }
1481
1482         set_ir_status full
1483
1484         # get one of the clients from client list
1485         local rcli=$(echo $RCLIENTS |cut -d' ' -f 1)
1486
1487         local old_MOUNTOPT=$MOUNTOPT
1488         MOUNTOPT=${MOUNTOPT},noir
1489         zconf_umount $rcli $MOUNT || error "umount failed"
1490         zconf_mount $rcli $MOUNT || error "mount failed"
1491
1492         # make sure lustre mount at $rcli disabling IR
1493         local ir_state=$(check_cli_ir_state $rcli)
1494         [ $ir_state = "DISABLED" -o $ir_state = "OFF" ] ||
1495                 error "IR state must be DISABLED at $rcli"
1496
1497         # Since the client just mounted, its last_rcvd entry is not on disk.
1498         # Send an RPC so exp_need_sync forces last_rcvd to commit this export
1499         # so the client can reconnect during OST recovery (LU-924, LU-1582)
1500         $SETSTRIPE -i 0 $DIR/$tfile
1501         dd if=/dev/zero of=$DIR/$tfile bs=1M count=1 conv=sync
1502
1503         # make sure MGS's state is Partial
1504         [ $(get_ir_status) = "partial" ] || error "MGS IR state must be partial"
1505
1506         fail ost1
1507         # make sure IR on ost1 is DISABLED
1508         local ir_state=$(check_target_ir_state ost1)
1509         [ $ir_state = "DISABLED" -o $ir_state = "OFF" ] ||
1510                 error "IR status on ost1 should be DISABLED"
1511
1512         # restore it
1513         MOUNTOPT=$old_MOUNTOPT
1514         zconf_umount $rcli $MOUNT || error "umount failed"
1515         zconf_mount $rcli $MOUNT || error "mount failed"
1516
1517         # make sure MGS's state is full
1518         [ $(get_ir_status) = "full" ] || error "MGS IR status must be full"
1519
1520         fail ost1
1521         # make sure IR on ost1 is ENABLED
1522         local ir_state=$(check_target_ir_state ost1)
1523         [ $ir_state = "ENABLED" -o $ir_state = "ON" ] ||
1524                 error "IR status on ost1 should be ENABLED"
1525
1526         return 0
1527 }
1528 run_test 105 "IR: NON IR clients support"
1529
1530 cleanup_106() {
1531         trap 0
1532         umount_client $DIR2
1533         debugrestore
1534 }
1535
1536 test_106() { # LU-1789
1537         [[ $(lustre_version_code $SINGLEMDS) -ge $(version_code 2.3.50) ]] ||
1538                 { skip "Need MDS version at least 2.3.50"; return 0; }
1539
1540 #define OBD_FAIL_MDC_LIGHTWEIGHT         0x805
1541         $LCTL set_param fail_loc=0x805
1542
1543         debugsave
1544         trap cleanup_106 EXIT
1545
1546         # enable lightweight flag on mdc connection
1547         mount_client $DIR2
1548
1549         local MDS_NEXP=$(do_facet $SINGLEMDS \
1550                          lctl get_param -n mdt.${mds1_svc}.num_exports |
1551                          cut -d' ' -f2)
1552         $LCTL set_param fail_loc=0
1553
1554         touch $DIR2/$tfile || error "failed to create empty file"
1555         replay_barrier $SINGLEMDS
1556
1557         $LCTL set_param debug=console
1558         $LCTL clear
1559         facet_failover $SINGLEMDS
1560
1561         # lightweight connection must be evicted
1562         touch -c $DIR2/$tfile || true
1563         $LCTL dk $TMP/lustre-log-$TESTNAME.log
1564         evicted=`awk '/This client was evicted by .*MDT0000/ {
1565                                       print;
1566                       }' $TMP/lustre-log-$TESTNAME.log`
1567         [ -z "$evicted" ] && error "lightweight client not evicted by mds"
1568
1569         # and all operations performed by lightweight client should be
1570         # synchronous, so the file created before mds restart should be there
1571         $CHECKSTAT -t file $DIR/$tfile || error "file not present"
1572         rm -f $DIR/$tfile
1573
1574         cleanup_106
1575 }
1576 run_test 106 "lightweight connection support"
1577
1578 test_107 () {
1579         local CLIENT_PID
1580         local close_pid
1581
1582         mkdir -p $DIR/$tdir
1583         # OBD_FAIL_MDS_REINT_NET_REP   0x119
1584         do_facet $SINGLEMDS lctl set_param fail_loc=0x119
1585         multiop $DIR/$tdir D_c &
1586         close_pid=$!
1587         mkdir $DIR/$tdir/dir_106 &
1588         CLIENT_PID=$!
1589         do_facet $SINGLEMDS lctl set_param fail_loc=0
1590         fail $SINGLEMDS
1591
1592         wait $CLIENT_PID || rc=$?
1593         checkstat -t dir $DIR/$tdir/dir_106 || return 1
1594
1595         kill -USR1 $close_pid
1596         wait $close_pid || return 2
1597
1598         return $rc
1599 }
1600 run_test 107 "drop reint reply, then restart MDT"
1601 complete $SECONDS
1602 check_and_cleanup_lustre
1603 exit_status